/* (C) 2018 King Kevin <kingkevin@cuvoodoo.info>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* configure the USI to have a UART output */

#define BAUDRATE 9600 /* serial baud rate (in bps) */

/* initialize UART peripheral
 * @note this only supports transmit
 */
void uart_init(void);
/* transmit character
 * @param[in] c character to transmit
 */
void uart_putchar(char c);
/* transmit unsigned integer value
 * @param[in] ui unsigned integer value to transmit as decimal
 */
void uart_putuint(uint32_t ui);
/* transmit hexadecimal value
 * @param[in] hex value to transmit as hexadecimal
 */
void uart_puthex(uint8_t hex);
/* transmit string
 * @param[in] str string to transmit
 */
void uart_putstr(const char* str);
/* transmit string stored in flash
 * @param[in] str string to transmit
 * @note use PSTR("...") to store the string in flash
 */
void uart_putstr_P(const char* str);
